#ifndef _KRBCDL_H

#define _KRBCDL_H

#include <windows.h>

#ifdef __cplusplus
extern "C" {
#endif

__declspec(dllexport) BOOL RCB_GetID(HANDLE hCom, BYTE *respuesta);
__declspec(dllexport) BOOL RCB_SetID(HANDLE hCom, BYTE id);
__declspec(dllexport) BOOL RCB_GetSwitchBits(HANDLE hCom, BYTE id, BYTE *respuesta);
__declspec(dllexport) BOOL RCB_SetSwitchBits(HANDLE hCom, BYTE id, BYTE switchValue);
__declspec(dllexport) BOOL RCB_GetHomePositions(HANDLE hCom, BYTE id, BYTE *respuesta);
__declspec(dllexport) BOOL RCB_SetHomePositions(HANDLE hCom, BYTE id);
__declspec(dllexport) BOOL RCB_GetMotorPositions(HANDLE hCom, BYTE id, BYTE *respuesta);
__declspec(dllexport) BOOL RCB_SetMotorPositions(HANDLE hCom, BYTE id, BYTE speed, BYTE *motordata);
__declspec(dllexport) BOOL RCB_GetTrimPositions(HANDLE hCom, BYTE id, signed char *respuesta);
__declspec(dllexport) BOOL RCB_SetTrimPositions(HANDLE hCom, BYTE id, signed char *motordata);
__declspec(dllexport) BOOL RCB_SetMotionPosition(HANDLE hCom, BYTE id, BYTE motion, BYTE posNumber, BYTE speed, BYTE *motordata);
__declspec(dllexport) BOOL RCB_GetMotionPositionCount(HANDLE hCom, BYTE id, BYTE motion, BYTE *respuesta);
__declspec(dllexport) BOOL RCB_SetMotionPositionCount(HANDLE hCom, BYTE id, BYTE motion, BYTE posNumber);
__declspec(dllexport) BOOL RCB_PlayMotion(HANDLE hCom, BYTE id, BYTE motion);
__declspec(dllexport) BOOL RCB_GetMotionPosition(HANDLE hCom, BYTE id, BYTE motion, BYTE position, BYTE *respuesta);
__declspec(dllexport) BOOL RCB_GetScenarioMotion(HANDLE hCom, BYTE id, BYTE scenario, BYTE motion, BYTE *respuesta);
__declspec(dllexport) BOOL RCB_SetScenarioMotion(HANDLE hCom, BYTE id, BYTE scenario, BYTE motionIndex, BYTE motion);
__declspec(dllexport) BOOL RCB_GetScenarioMotionCount(HANDLE hCom, BYTE id, BYTE scenario, BYTE *respuesta);
__declspec(dllexport) BOOL RCB_SetScenarioMotionCount(HANDLE hCom, BYTE id, BYTE scenario, BYTE motionNumber);
__declspec(dllexport) BOOL RCB_PlayScenario(HANDLE hCom, BYTE id, BYTE scenario);
__declspec(dllexport) HANDLE RCB_Start(BYTE portCom, DWORD flags, DWORD commandTimeout, DWORD maxRetries);
__declspec(dllexport) void RCB_End(HANDLE hCom);
									 

#define RCB_DEFAULT_VALUE (0xFFFFFFFF)
#define RCB_FLAGS_HIRES_TIMER	(1)

typedef struct{
	
	HANDLE hCom;
	unsigned long Flags;
	unsigned long CommandDelay;
	unsigned long MAX_RETRIES;
	unsigned long Retries;
	unsigned long CalcTime;
	LARGE_INTEGER t1;
	LARGE_INTEGER t2;
	DWORD	t3,t4;
	}RCB_CONFIG;

#define RCB_SET_DELAY(hCom, n) ((RCB_CONFIG*)hCom)->CommandDelay = (((RCB_CONFIG*)hCom)->Flags & RCB_FLAGS_HIRES_TIMER)? n/10:n
#define RCB_GET_DELAY(hCom)    (((RCB_CONFIG*)hCom)->Flags & RCB_FLAGS_HIRES_TIMER)? ((RCB_CONFIG*)hCom)->CommandDelay*10:((RCB_CONFIG*)hCom)->CommandDelay

#define RCB_SET_RETRIES(hCom,n)	((RCB_CONFIG*)hCom)->MAX_RETRIES = n
#define RCB_GET_RETRIES(hCom)	((RCB_CONFIG*)hCom)->MAX_RETRIES

#define RCB_GET_ACTUAL_RETRIES(hCom)  ((RCB_CONFIG*)hCom)->Retries

#ifdef __cplusplus
}
#endif

#endif

